package be.iminds.ilabt.jfed.espec.model;

import be.iminds.ilabt.jfed.espec.parser.ESpecDefaults;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.Collections;
import java.util.List;

/**
 * AnsiblePlaybookSpec
 */
public class AnsiblePlaybookSpec extends UploadLikeWithLogSpec {
    private final int debug;

    public AnsiblePlaybookSpec(@Nullable FileSource source,
                               @Nullable String path,
                               @Nullable String permissions,
                               @Nullable Integer debug,
                               @Nullable String log) {
        //nodes is special: always only on ansible node
        //                  value is ignored, but we put something anyway because null would mean ALL nodes and that's also not correct
        super(source, path, permissions == null ? "u=rwx" : permissions, Collections.singletonList("$ANSIBLE_NODE$"), log);

        this.debug = debug == null ? ESpecDefaults.ANSIBLE_DEBUG : debug;
    }

    public boolean isDebug() {
        return debug > 0;
    }

    /**
     * @return number of v's to add to ansible arguments
     */
    public int getDebug() {
        return debug;
    }
}
